import * as tslib_1 from "tslib";
import { Component } from 'react';
import * as React from 'react';
import * as classNames from 'classnames';
import Archer from 'archer-svgs';
var svgTarget = 'https://unpkg.com/ionicons@4.4.2/dist/ionicons/svg/';
/**
 * **图标**-展示对应的矢量化图标。
 */
var Icon = /** @class */ (function (_super) {
    tslib_1.__extends(Icon, _super);
    function Icon() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            svgHtml: ''
        };
        return _this;
    }
    Icon.prototype.componentDidMount = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var svg;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // 不使用ionicons图标时不进行加载，提高性能
                        if (!this.props.type) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, Archer.fetchSvg("" + svgTarget + this.props.type + ".svg")];
                    case 1:
                        svg = _a.sent();
                        this.setState({
                            svgHtml: svg,
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    Icon.prototype.componentWillReceiveProps = function (props) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var svg;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!props.type) {
                            return [2 /*return*/];
                        }
                        if (!(this.props.type !== props.type)) return [3 /*break*/, 2];
                        return [4 /*yield*/, Archer.fetchSvg("" + svgTarget + props.type + ".svg")];
                    case 1:
                        svg = _a.sent();
                        this.setState({
                            svgHtml: svg,
                        });
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    Icon.prototype.render = function () {
        var _a;
        var _b = this.props, className = _b.className, style = _b.style, type = _b.type, svg = _b.svg, otherProps = tslib_1.__rest(_b, ["className", "style", "type", "svg"]);
        var preCls = 'yoshino-icon';
        var clsName = classNames(preCls, className, (_a = {}, _a[preCls + "-" + type] = !!type, _a));
        return (React.createElement("i", tslib_1.__assign({ className: clsName, style: style, dangerouslySetInnerHTML: { __html: svg || this.state.svgHtml } }, otherProps)));
    };
    return Icon;
}(Component));
export { Icon };
export default Icon;
//# sourceMappingURL=Icon.js.map